natureMod = ...

natureMod:registerAssetProcessor("models/pine.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})

function registerTransparentMaterial(materialPath, id)
    natureMod:registerAssetId(materialPath, id)
    natureMod:override({
        Id = id,
        HasAlphaTest = true,
        BackFaceVisible = true,
        HasShadow = true,
    })
end

registerTransparentMaterial("models/pine.fbx/Materials/pine_needles", MOD_NS .. "TRANSPARENT_NEEDLES")
registerTransparentMaterial("models/pine.fbx/Materials/beech_leaves", MOD_NS .. "TRANSPARENT_BEECH_LEAVES")
registerTransparentMaterial("models/pine.fbx/Materials/maple_leaves", MOD_NS .. "TRANSPARENT_MAPLE_LEAVES")
registerTransparentMaterial("models/pine.fbx/Materials/maple_leaves_alt", MOD_NS .. "TRANSPARENT_MAPLE_LEAVES_ALT")
registerTransparentMaterial("models/pine.fbx/Materials/oak_leaves", MOD_NS .. "TRANSPARENT_OAK_LEAVES")
registerTransparentMaterial("models/pine.fbx/Materials/birch_leaves_2", MOD_NS .. "TRANSPARENT_BIRCH_LEAVES")
registerTransparentMaterial("models/pine.fbx/Materials/berry_leaves", MOD_NS .. "TRANSPARENT_BERRY_LEAVES")
registerTransparentMaterial("models/pine.fbx/Materials/grass", MOD_NS .. "TRANSPARENT_GRASS")
registerTransparentMaterial("models/pine.fbx/Materials/lavender", MOD_NS .. "TRANSPARENT_LAVENDER")
registerTransparentMaterial("models/pine.fbx/Materials/fern", MOD_NS .. "TRANSPARENT_FERN")
registerTransparentMaterial("models/pine.fbx/Materials/shrub_a", MOD_NS .. "TRANSPARENT_SHRUB_A")
registerTransparentMaterial("models/pine.fbx/Materials/forsythia", MOD_NS .. "TRANSPARENT_FORSYTHIA")
registerTransparentMaterial("models/pine.fbx/Materials/chamomile", MOD_NS .. "TRANSPARENT_FLOWER_CHAMOMILE")
registerTransparentMaterial("models/pine.fbx/Materials/stephanandra", MOD_NS .. "TRANSPARENT_STEPHANANDRA")

function registerShrub(fbxPath, name, resourceType, quantity)
    local prefabName = MOD_NS .. "PREFAB_" .. name
    natureMod:registerAssetId(fbxPath, prefabName)

    natureMod:registerPrefabComponent(fbxPath, {
        DataType = "COMP_RESOURCE_CONTAINER",
        ResourceData = resourceType,
        IsReplenishable = false,
        ResourceValue = quantity,
        AvailableQuantity = 1,
        Radius = 1.3,
        IsDestroyWhenEmpty = true,
        HasMaximumWorkstation = false
    })
    return prefabName
end

function registerTree(fbxPath, name)
    local prefabName = MOD_NS .. "PREFAB_" .. name
    natureMod:registerAssetId(fbxPath, prefabName)
    natureMod:registerPrefabComponent(fbxPath, {
        DataType = "COMP_RESOURCE_CONTAINER",
        ResourceData = "WOOD",
        IsReplenishable = false,
        ResourceValue = 2,
        AvailableQuantity = 1,
        Radius = 1.3,
        IsDestroyWhenEmpty = true,
        HasMaximumWorkstation = false
    })

    return prefabName
end

registerTree("models/pine.fbx/Prefab/PineAPart", "PINE_A")
registerTree("models/pine.fbx/Prefab/PineBPart", "PINE_B")
registerTree("models/pine.fbx/Prefab/PineCPart", "PINE_C")
registerTree("models/pine.fbx/Prefab/OakTreeAPart", "OAK_A")
registerTree("models/pine.fbx/Prefab/OakTreeBPart", "OAK_B")
registerTree("models/pine.fbx/Prefab/OakTreeCPart", "OAK_C")
registerTree("models/pine.fbx/Prefab/BeechTreeAPart", "BEECH_A")
registerTree("models/pine.fbx/Prefab/BeechTreeBPart", "BEECH_B")
registerTree("models/pine.fbx/Prefab/BeechTreeCPart", "BEECH_C")
registerTree("models/pine.fbx/Prefab/BeechTreeDPart", "BEECH_D")
registerTree("models/pine.fbx/Prefab/BeechSaplingAPart", "BEECH_SAPLING_A")
registerTree("models/pine.fbx/Prefab/MapleTreeAPart", "MAPLE_A")
registerTree("models/pine.fbx/Prefab/MapleTreeBPart", "MAPLE_B")
registerTree("models/pine.fbx/Prefab/BirchTreeAPart", "BIRCH_A")
registerTree("models/pine.fbx/Prefab/BirchTreeBPart", "BIRCH_B")
registerTree("models/pine.fbx/Prefab/BirchTreeCPart", "BIRCH_C")

registerShrub("models/pine.fbx/Prefab/ShrubAPart", "SHRUB_A", "WOOD", 1)
registerShrub("models/pine.fbx/Prefab/ShrubBPart", "SHRUB_FERN", "WOOD", 1)
registerShrub("models/pine.fbx/Prefab/ForsythiaPart", "SHRUB_FORSYTHIA", "WOOD", 1)
registerShrub("models/pine.fbx/Prefab/StephanandraPart", "SHRUB_STEPHANANDRA", "WOOD", 1)

registerShrub("models/pine.fbx/Prefab/LavenderPart", "SHRUB_LAVENDER", "HERBS", 10)
natureMod:registerPrefabComponent("models/pine.fbx/Prefab/LavenderPart", { DataType = "COMP_DIRT_CIRCLE", HardRadius = 0.7, SoftRadius = 1.2})

registerShrub("models/pine.fbx/Prefab/PopiesPart", "FLOWER_POPPIES", "HERBS", 5)
natureMod:registerPrefabComponent("models/pine.fbx/Prefab/PopiesPart", { DataType = "COMP_GROUNDED", SetOrientation = true, YOffset = 0.45, AutoDisable = true })

registerShrub("models/pine.fbx/Prefab/ChamomilePart", "FLOWER_CHAMOMILE", "HERBS", 5)
natureMod:registerPrefabComponent("models/pine.fbx/Prefab/ChamomilePart", { DataType = "COMP_GROUNDED", SetOrientation = true, YOffset = 0.2, AutoDisable = true })

natureMod:registerAssetId("models/pine.fbx/Prefab/BerryBushPart", MOD_NS .. "PREFAB_BERRY_BUSH")
natureMod:registerPrefabComponent("models/pine.fbx/Prefab/BerryBushPart", { DataType = "COMP_GROUNDED", SetOrientation = true, AutoDisable = true})
natureMod:registerPrefabComponent( "models/pine.fbx/Prefab/BerryBushPart", {
    DataType = "COMP_RESOURCE_CONTAINER",
    ResourceData = "BERRIES",
    IsReplenishable = true,
    ReplenishDurationInDays = 7,
    ReplenishQuantity = 300,
    ResourceValue = 2.0,
    AvailableQuantity = 300,
    Radius = 0.85,
    IsDestroyWhenEmpty = false,
    HasMaximumWorkstation = false
})


registerTree("models/trees.fbx/Prefab/OakA", "TREES_OAK_A")
registerTree("models/trees.fbx/Prefab/PineA", "TREES_PINE_A")

registerTransparentMaterial("models/trees.fbx/Materials/pine_needles", MOD_NS .. "TRANSPARENT_PINE_LEAVES_2")
registerTransparentMaterial("models/trees.fbx/Materials/leaves", MOD_NS .. "TRANSPARENT_OAK_LEAVES_2")